/*	Make it bobble
	Andrew Hedges, andrew@hedges.name
	2009-02-20
*/

$(function () {
	var rotator, bouncer, duration, heads, head;
	
	duration = 7500;
	
	heads = {
		'-3' : 'assets/imgs/_3.png',
		'-2' : 'assets/imgs/_2.png',
		'-1' : 'assets/imgs/_1.png',
		 '0' : 'assets/imgs/0.png',
		 '1' : 'assets/imgs/1.png',
		 '2' : 'assets/imgs/2.png',
		 '3' : 'assets/imgs/3.png'
	};
	
	$('#head').click(function (evt) {
		var head, start, idx, dir, limit;
		
		clearInterval(rotator);
		
		head  = this;
		start = (new Date()).getTime();
		idx   = 0;
		dir   = 1;
		
		// rotate fully at first, approaching 0 rotation as time runs down
		rotator = setInterval(function () {
			var diff, limit;
			diff  = (new Date()).getTime() - start;
			if (diff > duration) {
				clearInterval(rotator);
				head.src = heads[0];
				return;
			}
			limit = 3;
			if (diff > duration / 4) limit = 2;
			if (diff > duration / 2) limit = 1;
			head.src = heads[idx];
			idx = idx + dir;
			if (idx > limit) {
				idx = limit;
				dir = -1;
			}
			else if (idx < -limit) {
				idx = -limit;
				dir = 1;
			}
		}, 25);
		
		// move randomly within the limits, with the limits approaching 0 from the starting point
		bouncer = setInterval(function () {
			var rest, diff, limit, jump_left, jump_top, top, left;
			rest = 10;
			diff = (new Date()).getTime() - start;
			if (diff > duration) {
				clearInterval(bouncer);
				$(head).animate({
					top  : rest + 'px',
					left : rest + 'px'
				}, 50);
				return;
			}
			limit = 10 - (10 * (diff / duration));
			jump_top  = (Math.floor(Math.random() * limit) + (10 - limit)) / 2;
			jump_left = Math.floor(Math.random() * limit) + (10 - limit);
			jump_top  = 1 === Math.floor(Math.random() * 2) ? jump_top  : -jump_top;
			jump_left = 1 === Math.floor(Math.random() * 2) ? jump_left : -jump_left;
			new_top   = parseInt($(head).css('top'), 10) + jump_top;
			new_left  = parseInt($(head).css('left'), 10) + jump_left;
			if (new_top < 10 - limit) new_top = 10 - limit;
			if (new_top > limit + 10) new_top = limit + 10;
			if (new_left < 10 - limit) new_left = 10 - limit;
			if (new_left > limit + 10) new_left = limit + 10;
			$(head).animate({
				top  : new_top + 'px',
				left : new_left + 'px'
			}, 50);
		}, 100);
	});
	// END: $('#head').click()
	
	$('#follow').click(function (evt) {
		widget.openURL('http://twitter.com/segdeha');
	});
	// END: $('#hand').click()
	
});